{ pkgs ? import <nixpkgs> { } }:
let manifest = (pkgs.lib.importTOML ./Cargo.toml).package;
in
pkgs.rustPlatform.buildRustPackage rec {
  pname = manifest.name;
  version = manifest.version;
  cargoLock.lockFile = ./Cargo.lock;
  src = pkgs.lib.cleanSource ./.;

  nativeBuildInputs = with pkgs; [
    # we need this to properly configure dependencies like openssl
    pkg-config
  ];
  
  buildInputs = with pkgs; [
    openssl
    pkg-config
    cacert
    cargo
    cargo-make
    cargo-cross
    gtk4
    wrapGAppsHook4 # this is needed for relm4-icons to properly load after gtk::init()
    libadwaita
    gobject-introspection
    lldb
    # (rust-bin.selectLatestNightlyWith( toolchain: toolchain.default.override {
    #   extensions= [ "rust-src" "rust-analyzer" ];
    #   targets = [ "wasm32-unknown-unknown" "aarch64-unknown-linux-gnu" "aarch64-unknown-linux-musl" ];
    # }))
    rustc
    perl
  ];
}

