{
  description = "A basic Rust devshell for NixOS users developing gtk/libadwaita apps";

  inputs = {
    nixpkgs.url      = "github:NixOS/nixpkgs/nixos-unstable";
    rust-overlay.url = "github:oxalica/rust-overlay";
  };

  outputs = { self, nixpkgs, ... }:
      let
        supportedSystems = [ "x86_64-linux" ];
        forAllSystems = nixpkgs.lib.genAttrs supportedSystems;
        pkgsFor = nixpkgs.legacyPackages;
      in
      
      {
        packages = forAllSystems (system: {
          default = pkgsFor.${system}.callPackage ./default.nix { };
        });

        devShells = forAllSystems (system: {
          default = pkgsFor.${system}.callPackage ./shell.nix { };
        });
      };
}
