# About this app

## Motivation

This app started as a hobby project, since i am interested in testing out Linux phones as a daily driver and found it difficult to use,
because most of my online accounts are protected by long and complicated passwords stored in my Vaultwarden instance.
Since Bitwarden itself as a company has other priorities right now than to provide a mobile Linux client, i tried to build one on my own.

## Name

Bitritter is a combination of Bitwarden, which the client aims to be compatilble with and the german word Ritter, which means knight.

## Installation

### Manual installation
Right now the only way to install is to clone this repository and compile it yourself.
Usually it can be done via
``` shell
  cargo build --release
```
with `cargo` installed (usually via `rustup`).
A binary named `bitritter` should then appear in the `target/release/` directory.

### Installation via package manager
#### PostMarketOS
The app is in the testing repositories of Alpine already, so if you have that enabled, just use
``` shell
  apk add bitritter
```
usually with root permissions.

#### NixOS
coming soon

#### Other
Help appreciated with formats like Mobian, Flatpak etc.

## Usage

- Add a vault via the Menu or the button (button is available when no vault has been added).
- Use the password prompt to login to and unlock your vault.
- Select a vault entry by clicking on it (check supported types below)
- Copy information (TOTP not supported yet)
- Open a URI (Link) via your system's portal, usually in a browser

## State

This app is still in a very early stage of development, but i wanted to upload my work, because there were several people interested in seeing
it and maybe even contributing to it. Release early, release often, eh?

## Feature list
- [x] Add a vault via GUI
- [x] Persist the vault information and active vault (later needed for switching) information
- [x] Login to a server
- [x] Sync your vault
- [ ] Manual Sync via button
- [x] Unlock the vault
- [ ] Look at Entry details
  - [x] Login
  - [x] Card
  - [ ] Identity
  - [ ] Note
- [ ] Edit Entry details
- [ ] Save edited details to the vault
- [x] Basic filter and search capabilities on the list

### Personal Vault
- [x] Decrypt values to show on the detail page
- [x] Copy values from the detail page
- [ ] provide TOTP token
- [x] decrypt URIs
- [x] open links/URIs directly from the detail page

### Organisation Vault

Not yet supported

# Alternatives
After my first proof of concept, i got informed about [Goldwarden](https://github.com/quexten/goldwarden), which has similar goals. 
I think it is more feature complete right now, so maybe it is interesting for you aswell.

# Contributing
Please refrain from opening issues about lacking features, since i got many topics on my list already.
PRs for improving my coding style are welcome, but please do not rewrite the whole code...
If there are bugs right now, you can open an issue, but since the app is quite unstable, i am not sure they get addressed
very soon. I hope that can change if i can get the basic features stabilized.

